#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-
# generated by wxGlade 0.6.5 (standalone edition) on Mon May 07 18:41:17 2012

import wx, math, itertools, Pyro4, random
import engine, colours
import wx.lib.agw.toasterbox as TB
import threading

Pyro4.config.COMPRESSION = True
Pyro4.config.HOST = engine.SERVER

PADDING = 25

# begin wxGlade: extracode
# end wxGlade

def toast_maker(parent,text):
    toaster = TB.ToasterBox(parent, tbstyle=TB.TB_SIMPLE)
    toaster.SetPopupPauseTime(5000)
    toaster.SetPopupText(text)
    toaster.SetPopupSize((200,100))
    toaster.SetPopupPositionByInt(3)
    toaster.SetPopupTextFont(wx.Font(15,wx.FONTFAMILY_DEFAULT,wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_NORMAL))
    ALERT.Play(wx.SOUND_ASYNC)
    wx.CallLater(0, toaster.Play)

myEVT_UPDATE_GAMES = wx.NewEventType()
EVT_UPDATE_GAMES = wx.PyEventBinder(myEVT_UPDATE_GAMES, 1)
class UpdateGamesEvent(wx.PyCommandEvent):
    """Event to signal that a count value is ready"""
    def __init__(self, etype, eid, value=None):
        """Creates the event object"""
        wx.PyCommandEvent.__init__(self, etype, eid)
        self._value = value

    def GetValue(self):
        """Returns the value from the event.
        @return: the value of this event

        """
        return self._value

class UpdaterThread(threading.Thread):
    def __init__(self, parent, server, username):
        """
        @param parent: The gui object that should recieve the value
        @param value: value to 'calculate' to
        """
        threading.Thread.__init__(self)
        self._parent = parent
        self.server = server
        self.username = username

    def run(self):
        """Overrides Thread.run. Don't call this directly its called internally
        when you call Thread.start().
        """
        self._parent.main_game_statusbar.SetStatusText("UPDATING", 0)
        games = self.server.get_all_games(self._parent.username)
        toasts = []
        
        waiting_games_old=self._parent.waiting_games.keys()

        for game in self._parent.all_games:
            self._parent.games_all_menu.Remove(game)
                
        for game in self._parent.waiting_games:
            self._parent.games_waiting.Remove(game)
            
        self._parent.all_games = {}
        self._parent.waiting_games = {}
        
        for game in games:
            index = game.GetId()
            other = game.other_player(self._parent.username)
            self._parent.games_all_menu.Append(index,other,"",wx.NORMAL)
            self._parent.all_games[index] = game
            if game.waiting_for(self._parent.username):
                ID = self._parent.games_waiting.Append(index,other)
                self._parent.Bind(wx.EVT_MENU, self._parent.change_game,id=index)
                self._parent.waiting_games[index] = game
                winner = game.game_over(self._parent.username)
                if winner:
                    if winner == self._parent.username:
                        wx.MessageDialog(None, 'Congratulations you won the game against %s'%other, 'Results', wx.OK | wx.ICON_EXCLAMATION).ShowModal()
                    else:
                        wx.MessageDialog(None, 'You lost the game against %s'%winner, 'Results', wx.OK | wx.ICON_EXCLAMATION).ShowModal()
                if not index in waiting_games_old:                    
                    toasts.append("New Move With\n%s"%other)
        
        self._parent.main_game_statusbar.SetStatusText("DONE", 0)
        evt = UpdateGamesEvent(myEVT_UPDATE_GAMES, -1, toasts)
        wx.PostEvent(self._parent, evt)
        

class Field(wx.Panel):
    def __init__(self,window,*args, **kwds):
        self.window = window
        kwds["style"] = wx.TAB_TRAVERSAL
        wx.Panel.__init__(self, *args, **kwds)
        
        self.buildings = []
        self.new_buildings = []
        self.destroyed = []
        
        self.Bind(wx.EVT_PAINT, self.on_paint)
        self.Bind(wx.EVT_MOTION, self.on_mouse_motion)
        self.Bind(wx.EVT_LEFT_DOWN, self.on_mouse_left_down)
        self.Bind(wx.EVT_LEFT_UP, self.on_mouse_left_up)
        self.Bind(wx.EVT_RIGHT_DOWN, self.on_mouse_right_down)
        
        self.selected_building = None
        self.dragging=False
        self.rotated=False
        
        self.enemy_miss = []
        self.enemy_miss_old = []
        self.enemy_hit_old  = []
        self.enemy_hit  = []
        self.enemy_destroyed = []
        
        self.production = 0
        self.build_points = 0
        
        self.game = None
        
        
    def on_paint(self,event):
        if self.game:
            dc = wx.PaintDC(self)
            
            center  = self.width()/2
            h_left  = center+PADDING-self.height()
            h_right = center-PADDING
            e_left  = center+PADDING
            e_right = center-PADDING+self.height()
            
            #print h_right-h_left, e_right-e_left, self.height()-PADDING*2
            
            self.draw_grid(dc,h_left,PADDING,h_right,self.height()-PADDING)
            self.draw_grid(dc,e_left,PADDING,e_right,self.height()-PADDING)
            
            width = float(h_right-h_left)/engine.GRID_SIZE
            
            for building in itertools.chain(self.buildings,self.new_buildings):
                for x, y in building.squares():
                    if not (x,y) in building.damage:
                        dc.DrawBitmap(wx.BitmapFromImage(building.image.Scale(width-1, width-1)),math.floor(x*width)+h_left, math.floor(y*width)+PADDING, useMask=False)
                    else:
                        dc.DrawBitmap(wx.BitmapFromImage(colours.rubble.Scale(width-1, width-1)),math.floor(x*width)+h_left, math.floor(y*width)+PADDING, useMask=False)
                    
            for building in self.destroyed:
                for x, y in building.squares():
                    dc.DrawBitmap(wx.BitmapFromImage(colours.rubble.Scale(width-1, width-1)),math.floor(x*width)+h_left, math.floor(y*width)+PADDING, useMask=False)
                    
            for building in self.new_buildings:
                dc.SetPen(wx.Pen(colours.NEW_BUILDING,3))
                dc.SetBrush(wx.TRANSPARENT_BRUSH)
                dc.DrawRectangle(building.x*width+h_left,building.y*width+PADDING,width*building.width,width*building.height)
                
            if self.selected_building and type(self.selected_building) != type:
                dc.SetPen(wx.Pen(colours.SELECTED_BUILDING,3))
                dc.SetBrush(wx.TRANSPARENT_BRUSH)
                dc.DrawRectangle(self.selected_building.x*width+h_left,self.selected_building.y*width+PADDING,width*self.selected_building.width,width*self.selected_building.height)
                
            if self.selected_building and type(self.selected_building) == type:
                g, x,y = self.mouse_2_grid(wx.GetMousePosition().x-self.GetScreenPosition().x,wx.GetMousePosition().y-self.GetScreenPosition().y)
                if g == 1:
                    new = self.selected_building(x,y,self.rotated)
                    if self.empty_for_building(new):
                        #if g == 1 and x >= 0 and y >= 0 and x+building.width < engine.GRID_SIZE and y+building.height < engine.GRID_SIZE:
                        dc.SetPen(wx.Pen(colours.SELECTED_BUILDING_OUTLINE,3))
                        dc.SetBrush(wx.Brush(colours.SELECTED_BUILDING_OUTLINE))
                        dc.DrawRectangle(x*width+h_left,y*width+PADDING,width*new.width,width*new.height)
                
            for building in itertools.chain(self.buildings,self.new_buildings):
                if building.hostile:
                    dc.SetPen(wx.Pen(colours.TARGET_ENEMY,2,wx.DOT_DASH))
                elif self.window.show_all_power_links.IsChecked() or building == self.selected_building:
                    dc.SetPen(wx.Pen(colours.TARGET_FRIENDLY,2,wx.DOT_DASH))
                else: continue
                for target in building.targets:
                    x1,y1 = self.grid_2_screen(1,building.x+building.width/2.0,building.y+building.height/2.0)
                    x2,y2 = self.grid_2_screen(target[0],target[1]+0.5,target[2]+0.5)
                    dc.DrawLine(x1,y1,x2,y2)
                    
            if self.selected_building and self.dragging:
                dc.SetPen(wx.Pen(colours.TARGET_SELECTED,2))
                pos1 = self.grid_2_screen(1,self.selected_building.x+self.selected_building.width/2.0,self.selected_building.y+self.selected_building.height/2.0)
                dc.DrawLine(pos1[0],pos1[1],wx.GetMousePosition().x-self.GetScreenPosition().x,wx.GetMousePosition().y-self.GetScreenPosition().y)
            
            dc.SetPen(wx.TRANSPARENT_PEN)
            for shot in self.enemy_miss_old:
                dc.SetBrush(wx.Brush(colours.ENEMY_HIT_OLD))
                dc.DrawRectangle(shot[0]*width+e_left,shot[1]*width+PADDING,width-1,width-1)
            for shot in self.enemy_hit_old:
                dc.SetBrush(wx.Brush(colours.ENEMY_MISS_OLD))
                dc.DrawRectangle(shot[0]*width+e_left,shot[1]*width+PADDING,width-1,width-1)
                    
            for shot in self.enemy_hit:
                dc.SetBrush(wx.Brush(colours.ENEMY_HIT))
                dc.DrawRectangle(shot[0]*width+e_left,shot[1]*width+PADDING,width-1,width-1)
            for shot in self.enemy_miss:
                dc.SetBrush(wx.Brush(colours.ENEMY_MISS))
                dc.DrawRectangle(shot[0]*width+e_left,shot[1]*width+PADDING,width-1,width-1)
                
            for building in self.enemy_destroyed:
                for x, y in building.squares():
                    dc.DrawBitmap(wx.BitmapFromImage(building.image.Scale(width-1, width-1)),math.floor(x*width)+e_left, math.floor(y*width)+PADDING, useMask=False)
        else:
            dc = wx.PaintDC(self)
            font = wx.Font(20,wx.FONTFAMILY_DEFAULT,wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_BOLD)
            dc.SetFont(font)
            dc.DrawLabel("No Active Games\nIf you are already in a game select one from the menu above",(0,0)+dc.GetSizeTuple(),wx.ALIGN_CENTER|wx.ALIGN_CENTER_VERTICAL)
        
    def on_mouse_motion(self,event):
        if self.game:
            if self.selected_building and (self.dragging or type(self.selected_building) == type):
                self.Refresh()
        
    def on_mouse_left_down(self,event):
        if self.game:
            grid, x,y = self.mouse_2_grid(*event.GetPosition())
            if grid == 1:
                if type(self.selected_building) == type:
                    clear = True
                    new = self.selected_building(x,y,self.rotated)
                    if self.empty_for_building(new):
                        self.new_buildings.append(new)
                    self.window.ToolBar.ToggleTool(self.window.build_tools[self.selected_building].Id,False)
                    self.selected_building = None
                    self.Refresh()
                    self.update_building_list()
                            
                else:
                    building = engine.building_at(itertools.chain(self.buildings,self.new_buildings),x,y)
                    self.selected_building = building
                    self.dragging=True
                    self.Refresh()
            
    def on_mouse_left_up(self,event):
        if self.game:
            if self.selected_building and type(self.selected_building) != type and self.dragging and (not self.selected_building.needs_charge or self.selected_building.charge):
                self.selected_building.target(self.mouse_2_grid(*event.GetPosition()))
                self.Refresh()
                self.update_building_list()
            self.dragging=False
        
    def on_mouse_right_down(self,event):
        if self.game:
            self.rotated = not self.rotated
                
    
    def mouse_2_grid(self,x,y):
        center  = self.width()/2
        h_left  = center+PADDING-self.height()
        h_right = center-PADDING
        e_left  = center+PADDING
        e_right = center-PADDING+self.height()
        
        if h_left <= x <= h_right and y > PADDING and y < self.height()-PADDING:
            return 1, math.floor((x-h_left) * engine.GRID_SIZE / float(h_right-h_left)), math.floor((y-PADDING) * engine.GRID_SIZE / float(h_right-h_left))
        elif e_left <= x <= e_right and y > PADDING and y < self.height()-PADDING:
            return 2, math.floor((x-e_left) * engine.GRID_SIZE / float(e_right-e_left)), math.floor((y-PADDING) * engine.GRID_SIZE / float(e_right-e_left))
                
        return 0, 0 ,0
    
    def grid_2_screen(self,grid, x,y):
        center  = self.width()/2
        h_left  = center+PADDING-self.height()
        h_right = center-PADDING
        e_left  = center+PADDING
        e_right = center-PADDING+self.height()
        
        x *= float(h_right-h_left)/engine.GRID_SIZE
        y *= float(h_right-h_left)/engine.GRID_SIZE
        
        y += PADDING
        if grid == 1:
            x+= h_left
        else:
            x+= e_left
            
        return x,y
    
    def empty_for_building(self,new):
        if not (new.x >= 0 and new.y >= 0 and new.x+new.width < engine.GRID_SIZE+1 and new.y+new.height < engine.GRID_SIZE+1): return False
        for building in itertools.chain(self.buildings,self.new_buildings,self.destroyed):
            for square in building.squares():
                if square in new.squares():
                    return False
        return True
    
    def on_toolbar(self,building,event):
        if sum(building.production for building in self.buildings) + 1 >= sum(building.cost for building in self.new_buildings)+building.cost and \
            sum(building.buildpoints for building in self.buildings) >= len(self.new_buildings):
                self.selected_building = building
        else:
            self.window.ToolBar.ToggleTool(self.window.build_tools[building].Id,False)
            wx.MessageDialog(None, 'Insufficient Resources', 'Doh...', wx.OK | wx.ICON_EXCLAMATION).ShowModal()
                
        
    def width(self):
        return self.GetClientSize().GetWidth()

    def height(self):
        return self.GetClientSize().GetHeight()
        
    def square_size(self):
        limit = min(self.width(),self.height())
        
    def draw_grid(self,dc,left,top,right,bottom):
        bottom-=1
        right-=1
        width = float(right-left)/engine.GRID_SIZE
        height  = float(bottom-top)/engine.GRID_SIZE

        for x in xrange(engine.GRID_SIZE+1):
            dx=math.floor(x*width)
            dy=math.floor(x*height)
            dc.DrawLine(left,top+dy,right,top+dy)
            dc.DrawLine(left+dx,top,left+dx,bottom)
            
    def update_building_list(self):
        self.window.list_buildings.DeleteAllItems()
        index = 0
        for building in itertools.chain(self.buildings,self.new_buildings):
            self.window.list_buildings.InsertStringItem(index, building.verbose_name)
            self.window.list_buildings.SetStringItem(index, 1, "%d"%(building.charge))
            self.window.list_buildings.SetStringItem(index, 2, "%d / %d"%(len(building.targets),building.max_targets))
            index += 1
            
        self.window.list_resource.DeleteAllItems()
        self.window.list_resource.InsertStringItem(0, "Gold")
        self.window.list_resource.SetStringItem(0, 1, "%d/%d"%(sum(building.cost for building in self.new_buildings),sum(building.production for building in self.buildings)+1))
        self.window.list_resource.InsertStringItem(1, "Build Points")
        self.window.list_resource.SetStringItem(1, 1, "%d/%d"%(len(self.new_buildings),sum(building.buildpoints for building in self.buildings)+1))
            
    def ping(self): return True
    
    def swap_game(self,game):
        self.selected_building=None
        self.game = game
        self.new_buildings = []
        self.buildings = game.get_buildings(self.window.username)
        self.enemy_hit,self.enemy_miss,self.enemy_hit_old,self.enemy_miss_old = game.get_hits_and_misses(self.window.username)
        self.destroyed = game.get_destroyed(self.window.username)
        self.enemy_destroyed = game.get_enemy_destroyed(self.window.username)
        
        self.Refresh()
        self.update_building_list()
        
    def make_move(self):
        if not self.game.make_move(self.window.username,self.buildings,self.new_buildings):
            self.game = None
            self.buildings = []
            self.new_buildings = []
            self.Refresh()
            self.update_building_list()
        else:
            self.swap_game(self.game)

# end of class Field
class MainGameFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        self.server = Pyro4.core.Proxy('PYRONAME:deathray.gameserver@%s:9090'%engine.SERVER)
        get_username = wx.TextEntryDialog(None, "Enter Username, theres no passwords as of yet so dont be a jerk", 'Username', '')
        if get_username.ShowModal() == wx.ID_OK and get_username.GetValue():
            self.username = get_username.GetValue()
        else:
            raise ValueError("Unable to get username")
        #self.username = "Hugo"+str(random.randint(0,1000))
        
        print self.server.ping()

        # begin wxGlade: MainGameFrame.__init__
        kwds["style"] = wx.CAPTION | wx.CLOSE_BOX | wx.MINIMIZE_BOX | wx.SYSTEM_MENU | wx.SIMPLE_BORDER
        wx.Frame.__init__(self, *args, **kwds)
        self.window_splitter = wx.SplitterWindow(self, -1, style=wx.SP_3D | wx.SP_BORDER)
        self.field_panel = Field(self,self.window_splitter, -1, style=wx.STATIC_BORDER | wx.TAB_TRAVERSAL | wx.FULL_REPAINT_ON_RESIZE)
        self.info_panel = wx.Panel(self.window_splitter, -1)
        self.list_resource = wx.ListCtrl(self.info_panel, -1, style=wx.LC_REPORT | wx.SUNKEN_BORDER)
        self.sizer_resources_staticbox = wx.StaticBox(self.info_panel, -1, "Resources")
        self.list_buildings = wx.ListCtrl(self.info_panel, -1, style=wx.LC_REPORT | wx.SUNKEN_BORDER)
        self.sizer_buildings_staticbox = wx.StaticBox(self.info_panel, -1, "Buildings")
        self.list_combat = wx.ListCtrl(self.info_panel, -1, style=wx.LC_REPORT | wx.SUNKEN_BORDER)
        self.sizer_combat_staticbox = wx.StaticBox(self.info_panel, -1, "Combat Log")
        
        # Menu Bar
        self.main_game_menubar = wx.MenuBar()
        self.options_menu = wx.Menu()
        self.show_all_power_links = wx.MenuItem(self.options_menu, wx.NewId(), "Show All Power Links", "", wx.ITEM_CHECK)
        self.options_menu.AppendItem(self.show_all_power_links)
        self.main_game_menubar.Append(self.options_menu, "Options")
        self.games_all_menu = wx.Menu()
        self.main_game_menubar.Append(self.games_all_menu, "All Games")
        self.games_waiting = wx.Menu()
        self.main_game_menubar.Append(self.games_waiting, "Waiting Games")
        self.SetMenuBar(self.main_game_menubar)
        
        # Menu Bar end
        self.main_game_statusbar = self.CreateStatusBar(1, 0)
        
        # Tool Bar
        self.main_game_toolbar = wx.ToolBar(self, -1, style=wx.TB_HORIZONTAL | wx.TB_TEXT)
        self.SetToolBar(self.main_game_toolbar)
        ID = self.main_game_toolbar.AddLabelTool(wx.NewId(), "Join Game", wx.BitmapFromImage(colours.join_game), wx.NullBitmap, wx.ITEM_NORMAL, "Attempt to join a new game", "")
        self.Bind(wx.EVT_TOOL, self.join_game, ID)
        ID = self.main_game_toolbar.AddLabelTool(wx.NewId(), "End Turn", wx.BitmapFromImage(colours.end_turn), wx.NullBitmap, wx.ITEM_NORMAL, "Attempt to join a new game", "")
        self.Bind(wx.EVT_TOOL, self.end_turn, ID)
        ID = self.main_game_toolbar.AddLabelTool(wx.NewId(), "Surrender", wx.BitmapFromImage(colours.surrender), wx.NullBitmap, wx.ITEM_NORMAL, "Attempt to join a new game", "")
        self.Bind(wx.EVT_TOOL, self.surrender, ID)
        self.main_game_toolbar.AddSeparator()
        self.main_game_toolbar.AddSeparator()
        # Tool Bar end
        
        self.build_tools = {}
        def buildit_generator(building):
            return lambda e: self.field_panel.on_toolbar(building,e)
        for building in engine.buildings:
            ID = self.main_game_toolbar.AddLabelTool(wx.NewId(), building.verbose_name, wx.BitmapFromImage(building.image), wx.NullBitmap, wx.ITEM_RADIO, building.help_text, "")
            self.Bind(wx.EVT_TOOL, buildit_generator(building), ID)
            self.build_tools[building]=ID            

        self.__set_properties()
        self.__do_layout()
        # end wxGlade
        
        self.list_buildings.InsertColumn(0,"Name",width=100)
        self.list_buildings.InsertColumn(1,"Charge")
        self.list_buildings.InsertColumn(2,"Links")
        
        self.list_resource.InsertColumn(0,"Name",width=100)
        self.list_resource.InsertColumn(1,"Amount")
        
        self.ToolBar.ToggleTool(ID.Id,True)
        self.ToolBar.ToggleTool(ID.Id,False)
        
        self.all_games = {}
        self.waiting_games = {}
        
        self._contact_server()
        
        toast_maker(self,"Connected to Server\n"+engine.SERVER)
        
        self.Bind(EVT_UPDATE_GAMES,self.contact_server)
            

    def __set_properties(self):
        # begin wxGlade: MainGameFrame.__set_properties
        self.SetTitle("Deathrays with Friends")
        _icon = wx.EmptyIcon()
        _icon.CopyFromBitmap(wx.Bitmap("resources\\icon_small.png", wx.BITMAP_TYPE_ANY))
        self.SetIcon(_icon)
        self.SetSize((900, 650))
        self.main_game_statusbar.SetStatusWidths([-1])
        # statusbar fields
        main_game_statusbar_fields = ["frame_1_statusbar"]
        for i in range(len(main_game_statusbar_fields)):
            self.main_game_statusbar.SetStatusText(main_game_statusbar_fields[i], i)
        self.main_game_toolbar.Realize()
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MainGameFrame.__do_layout
        window_sizer = wx.BoxSizer(wx.VERTICAL)
        sizer_info = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_combat_staticbox.Lower()
        sizer_combat = wx.StaticBoxSizer(self.sizer_combat_staticbox, wx.HORIZONTAL)
        self.sizer_buildings_staticbox.Lower()
        sizer_buildings = wx.StaticBoxSizer(self.sizer_buildings_staticbox, wx.HORIZONTAL)
        self.sizer_resources_staticbox.Lower()
        sizer_resources = wx.StaticBoxSizer(self.sizer_resources_staticbox, wx.HORIZONTAL)
        sizer_resources.Add(self.list_resource, 1, wx.EXPAND, 0)
        sizer_info.Add(sizer_resources, 1, wx.EXPAND, 0)
        sizer_buildings.Add(self.list_buildings, 1, wx.EXPAND, 0)
        sizer_info.Add(sizer_buildings, 1, wx.EXPAND, 0)
        sizer_combat.Add(self.list_combat, 1, wx.EXPAND, 0)
        sizer_info.Add(sizer_combat, 1, wx.EXPAND, 0)
        self.info_panel.SetSizer(sizer_info)
        self.window_splitter.SplitHorizontally(self.field_panel, self.info_panel, 350)
        window_sizer.Add(self.window_splitter, 1, wx.EXPAND, 0)
        self.SetSizer(window_sizer)
        self.Layout()
        # end wxGlade
        
    def _contact_server(self):
        print "Checking Server For Games"
        worker = UpdaterThread(self, self.server,self.username)
        worker.start()
        
    def contact_server(self,event):
        for toast in  event.GetValue():
            toast_maker(self,toast)
        
        wx.CallLater(10000,self._contact_server)
        
    def change_game(self,event):
        self.field_panel.swap_game(self.waiting_games[event.Id])

    def join_game(self,event):
        got_game = self.server.join_game(self.username)
        if got_game:
            other = got_game.other_player(self.username)
            print "Game started with: %s"%other
            toast_maker(self,"Game started with\n%s"%other)
            self.field_panel.swap_game(got_game)
        else:
            print "Waiting for game"
            wx.MessageDialog(None, 'Game pool empty, you will be notified when a game has been found for you, \n At that point it will be accessible though the main menu', 'The Waiting Game', wx.OK | wx.ICON_EXCLAMATION).ShowModal()
        
    
    def end_turn(self,event):
        self.field_panel.make_move()
        
    def surrender(self,event):
        wx.MessageDialog(None, 'Surrender is not an option\nMabey if pyweek was longer...', '', wx.OK | wx.ICON_EXCLAMATION).ShowModal()

# end of class MainGameFrame
if __name__ == "__main__":
    app = wx.PySimpleApp(0)
    ALERT = wx.Sound(colours.alert)
    wx.InitAllImageHandlers()
    main_game_frame = MainGameFrame(None, -1, "")
    app.SetTopWindow(main_game_frame)
    main_game_frame.Show()
    app.MainLoop()
